array set CONFIG [list]

set ntasks 0

#
# Handler for setup information from the boss
#
proc config {name val} {
	global CONFIG
	set CONFIG($name) $val
}

#
# Handler for thread start - when told to start, we ask the boss
# for a task
#
proc start {} {
	global CONFIG
	thread::send -async $CONFIG(boss) [list next_task [thread::id]]
}

#
# Handler for stop messages - call thread::unwuind which will break us out
# of the wait section (below)
#
proc stop {} {
	thread::unwind
}

#
# Handler for a task - just log some info and get the next task - note that
# we're doing all this stuff with -async
#
proc handle {args} {
	global CONFIG
	global ntasks
	incr ntasks
	thread::send -async $CONFIG(logger) [list log task_done [thread::id]]
	after [expr {int(rand()*100)}]
	thread::send -async $CONFIG(boss)   [list next_task [thread::id]]
}

#
# This is the thread "event loop"
#
thread::wait

set tid [thread::id]

thread::send -async $CONFIG(boss)    "worker_exit $tid"
thread::send -async $CONFIG(logger)  "log $tid exiting..."

#return $ntasks
